SystemOrganization addCategory: #OMeta2!

Exception subclass: #OM2Fail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OM2Fail methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 11:03'!
defaultAction

	self error: 'match failed'! !

Compiler subclass: #OMeta2Compiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OMeta2Compiler methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 16:30'!
compile: origCode in: cls classified: aCategory notifying: notify ifFail: failBlock

	^ self compile: origCode in: cls notifying: notify ifFail: failBlock! !

!OMeta2Compiler methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:57'!
compile: origCode in: cls notifying: notify ifFail: failBlock

	| origCodeStream parseTree structuredCode translatedCode |
	origCodeStream := origCode asString readStream.
	self from: origCodeStream class: cls context: nil notifying: notify.
	[
		parseTree := OMeta2RuleParser matchStream: origCodeStream with: #rule withArgs: #() withPlaybackDebugging: false.
		parseTree := OMeta2Optimizer match: parseTree with: #optimizeRule.
		structuredCode := OMeta2RuleTranslator match: parseTree with: #translate withArgs: {cls}.
		translatedCode := OMeta2Flattener match: structuredCode with: #flatten
	] on: OM2Fail do: [
		self notify: '<-- parse error around here -->' at: origCodeStream position.
		^ failBlock value
	].
	^ Compiler new
		compile: translatedCode readStream
		in: cls
		notifying: notify
		ifFail: failBlock! !

!OMeta2Compiler methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 13:11'!
parse: aStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock

	^ [
		| parseTree structuredCode code |
		parseTree := OMeta2RuleParser matchAll: aStream contents with: #rule.
		structuredCode := OMeta2RuleTranslator match: parseTree with: #translate withArgs: {aClass}.
		code := OMeta2Flattener match: structuredCode with: #flatten.
		Parser new parse: code readStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock
	] on: OM2Fail do: [aBlock value]! !

!OMeta2Compiler methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 13:10'!
parserClass

	^ self class! !

Object subclass: #OM2Failer
	instanceVariableNames: 'used'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OM2Failer methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 14:23'!
initialize

	used := false! !

!OM2Failer methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 13:44'!
used

	^ used! !

!OM2Failer methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 13:42'!
value

	used := true.
	OMeta2Fail signal! !

Object subclass: #OM2Stream
	instanceVariableNames: 'head tail memo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

OM2Stream subclass: #OM2EndOfStream
	instanceVariableNames: 'stream pos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OM2EndOfStream methodsFor: 'as yet unclassified' stamp: 'aw 2/25/2009 11:29'!
head

	OMeta2Fail signal! !

!OM2EndOfStream methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:50'!
initStream: s pos: p

	stream := s.
	pos := p! !

!OM2EndOfStream methodsFor: 'as yet unclassified' stamp: 'aw 2/19/2009 23:14'!
inputSpecies

	^ stream originalContents species! !

!OM2EndOfStream methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:49'!
pos

	^ pos! !

!OM2EndOfStream methodsFor: 'as yet unclassified' stamp: 'aw 2/25/2009 11:29'!
tail

	OMeta2Fail signal! !

OM2Stream subclass: #OM2LazyStream
	instanceVariableNames: 'stream pos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OM2LazyStream class methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:44'!
for: aReadStream withPos: pos

	^ aReadStream atEnd
		ifTrue: [OM2EndOfStream new initStream: aReadStream pos: pos]
		ifFalse: [self new initHead: aReadStream next stream: aReadStream pos: pos]! !

!OM2LazyStream methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:50'!
initHead: h stream: s pos: p

	head := h.
	stream := s.
	pos := p! !

!OM2LazyStream methodsFor: 'as yet unclassified' stamp: 'aw 2/19/2009 23:15'!
inputSpecies

	^ stream originalContents species! !

!OM2LazyStream methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:43'!
pos

	^ pos! !

!OM2LazyStream methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:42'!
tail

	tail ifNil: [tail := OM2LazyStream for: stream withPos: pos + 1].
	^ tail! !

!OM2Stream methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 11:04'!
basicTail

	^ tail! !

!OM2Stream methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 11:38'!
forgetEverything

	memo := IdentityDictionary new! !

!OM2Stream methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 11:35'!
head

	^ head! !

!OM2Stream methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 13:38'!
initHead: h tail: t

	head := h.
	tail := t! !

!OM2Stream methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 11:34'!
initialize

	memo := IdentityDictionary new! !

!OM2Stream methodsFor: 'as yet unclassified' stamp: 'aw 2/19/2009 23:13'!
inputSpecies

	^ Array! !

!OM2Stream methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 14:13'!
memo

	^ memo! !

!OM2Stream methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:51'!
pos

	^ -1! !

!OM2Stream methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 11:05'!
printOn: aStream

	| inputIsString curr |
	inputIsString := (self inputSpecies inheritsFrom: String) and: [(self inputSpecies inheritsFrom: Symbol) not].
	curr := self.
	aStream
		nextPutAll: 'an ';
		nextPutAll: self class name;
		nextPut: $(.
	[curr notNil] whileTrue: [
		(curr isKindOf: OM2EndOfStream) ifTrue: [
			aStream nextPut: $).
			^ self
		].
		inputIsString
			ifTrue: [aStream nextPut: curr head]
			ifFalse: [
				curr head printOn: aStream.
				aStream space
			].
		curr := curr basicTail.
	].
	aStream nextPutAll: '...)'! !

!OM2Stream methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 11:35'!
tail

	^ tail! !

!OM2Stream methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 11:40'!
transitiveForgetEverything

	| curr |
	curr := self.
	[curr notNil] whileTrue: [
		curr forgetEverything.
		curr := curr basicTail
	]! !

OM2Stream subclass: #OM2StreamDebugger
	instanceVariableNames: 'om2stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OM2StreamDebugger class methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 15:28'!
for: anOM2Stream

	^ self new initOm2stream: anOM2Stream! !

!OM2StreamDebugger methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 13:28'!
forgetEverything

	om2stream forgetEverything! !

!OM2StreamDebugger methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 13:40'!
head

	^ om2stream head! !

!OM2StreamDebugger methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 15:26'!
initOm2stream: anOM2Stream

	om2stream := anOM2Stream! !

!OM2StreamDebugger methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 13:27'!
memo

	^ om2stream memo! !

!OM2StreamDebugger methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 15:57'!
printOn: aStream

	aStream nextPutAll: 'an OM2StreamDebugger('.
	om2stream printOn: aStream.
	aStream nextPut: $)! !

!OM2StreamDebugger methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 13:40'!
tail

	^ om2stream tail! !

!OM2StreamDebugger methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 13:29'!
transitiveForgetEverything

	om2stream transitiveForgetEverything! !

OM2Stream subclass: #OM2StreamProxy
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OM2StreamProxy class methodsFor: 'as yet unclassified' stamp: 'aw 2/19/2009 23:44'!
for: anOM2Stream

	^ self new initTarget: anOM2Stream! !

!OM2StreamProxy methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 11:05'!
basicTail

	^ target basicTail! !

!OM2StreamProxy methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 12:08'!
head

	head ifNil: [head := target head].
	^ head
! !

!OM2StreamProxy methodsFor: 'as yet unclassified' stamp: 'aw 2/19/2009 23:45'!
initTarget: anOM2Stream

	target := anOM2Stream! !

!OM2StreamProxy methodsFor: 'as yet unclassified' stamp: 'aw 2/19/2009 23:13'!
inputSpecies

	^ target inputSpecies! !

!OM2StreamProxy methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:51'!
pos

	^ target pos! !

!OM2StreamProxy methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 12:07'!
tail

	tail ifNil: [tail := OM2StreamProxy for: target tail].
	^ tail! !

!OM2StreamProxy methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 14:10'!
target

	^ target! !

Object subclass: #OMeta2Base
	instanceVariableNames: 'input om2streams haltingPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

OMeta2Base subclass: #OMeta2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OMeta2 commentStamp: '<historical>' prior: 0!
TODOS:

* implement OMeta -> Squeak translator
* implement Squeak parser
* implement OMeta/Squeak "compiler", make it OMeta2's compilerClass

* rewrite #char, #digit, #empty, #end, #exactly, #firstAndRest, #fromTo, #letter, #letterOrDigit, #listOf, #lower, #notLast, #number, #range, #space, #spaces, #string, #symbol, #token, and #upper in OMeta syntax
* consider implementing position-related functionality (see http://www.tinlizzie.org/ometa-js/ometa-base.js)
* consider the optimization suggestions in the comments of OMeta2Lib's methods!

OMeta2 subclass: #O2SqueakRecognizer
	instanceVariableNames: ''
	classVariableNames: 'TypeTable'
	poolDictionaries: ''
	category: 'OMeta2'!

!O2SqueakRecognizer class methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 02:04'!
initialize

	TypeTable := #(#xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xDelimiter #xDelimiter #xBinary #xDelimiter #xDelimiter #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #doIt #xBinary #xDelimiter #xBinary #xDoubleQuote #xLitQuote #xDollar #xBinary #xBinary #xSingleQuote #leftParenthesis #rightParenthesis #xBinary #xBinary #xBinary #xBinary #period #xBinary #xDigit #xDigit #xDigit #xDigit #xDigit #xDigit #xDigit #xDigit #xDigit #xDigit #xColon #semicolon #xBinary #xBinary #xBinary #xBinary #xBinary #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #leftBracket #xBinary #rightBracket #upArrow #leftArrow #xBinary #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #leftBrace #verticalBar #rightBrace #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xLetter #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xLetter #xBinary #xBinary #xBinary #xBinary #xLetter #xBinary #xBinary #xBinary #xBinary #xBinary #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xBinary #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xBinary #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xBinary)! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 00:43'!
arrayConstr =

	"{" expr ("." expr)* ("." | empty) "}"
|	"{" "}"! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 00:57'!
arrayLit =

	"#" "(" (literal | arrayLit | spaces tsArraySymbol)* ")"! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 00:57'!
binary =

	spaces tsBinary! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 00:58'!
binaryExpr =

	binaryExpr binaryMsg
|	unaryExpr! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 00:58'!
binaryMsg =

	binary unaryExpr! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:08'!
block =

	"["
		(	(":" identifier)+ "|"
		|	empty
		)

		(	"|" identifier* "|"
		|	empty
		)

		(	expr ("." expr)* ("." "^" expr | empty)
		|	"^" expr
		|	empty
		)

		(	"."
		|	empty
		)

	"]"! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 00:58'!
cascade =

	identifier
|	binaryMsg
|	keywordMsg! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 00:59'!
expr =

	identifier (":=" | "_") expr
|	msgExpr! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:18'!
identifier =

	spaces tsIdentifier ~$:! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:19'!
keyword =

	spaces tsKeyword! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:19'!
keywordExpr =

	binaryExpr keywordMsg! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:19'!
keywordMsg =

	keywordMsg keywordMsgPart
|	keywordMsgPart! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:20'!
keywordMsgPart =

	keyword binaryExpr! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:20'!
literal =

	spaces	(	tsNumber
			|	tsCharacter
			|	tsString
			|	tsSymbol
			)
! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:21'!
msgExpr =

	(keywordExpr | binaryExpr) (";" cascade)*! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:30'!
squeakExpr =

	<expr>! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:23'!
symbol =

	"#" spaces
		(	tsString
		|	tsKeyword (tsIdentifier | empty)
		)! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:23'!
tcBinaryChar =

	char:x ?[(TypeTable at: x asciiValue) == #xBinary]! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:25'!
tsArraySymbol =

	tsKeyword+ (tsIdentifier | empty)
|	tsIdentifier! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:25'!
tsBinary =

	($| | tcBinaryChar) tcBinaryChar*! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:25'!
tsCharacter =

	$$ char! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:26'!
tsIdentifier =

	letter (letter | digit)*! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:31'!
tsKeyword =

	tsIdentifier $:! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:26'!
tsNatural =

	digit+! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:27'!
tsNumber =

	($+ | $- | empty) tsNatural! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:28'!
tsString =

	$' ($' $' | ~$' char)* $'! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:28'!
tsSymbol =

	$# spaces (tsString | tsArraySymbol)! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:28'!
unaryExpr =

	unit identifier*! !

!O2SqueakRecognizer methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:29'!
unit =

	literal
|	identifier
|	arrayLit
|	arrayConstr
|	block
|	"(" expr ")"
! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 14:01'!
char

	| x |
	x := self apply: #anything.
	self pred: x isCharacter.
	^ x! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 14:05'!
digit

	| x |
	x := self apply: #char.
	self pred: x isDigit.
	^ x! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 16:14'!
empty

	^ true! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 16:17'!
end

	" may want to inline the sends below, since this rule gets used a lot "
	^ self not: [self apply: #anything]! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/25/2009 11:32'!
exactly

	| wanted got |
	wanted := self apply: #anything.
	got := self apply: #anything.
	self pred: wanted = got.
	^ wanted! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 13:52'!
firstAndRest

	| first rest |
	first := self apply: #anything.
	rest := self apply: #anything.
	^ self genericMany: [self apply: rest] into: (OrderedCollection with: (self apply: first))! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 15:40'!
fromTo

	| x y |
	x := self apply: #string.
	y := self apply: #string.
	self apply: #seq withArgs: {x}.
	self many: [
		self not: [self apply: #seq withArgs: {y}].
		self apply: #char
	].
	self apply: #seq withArgs: {y}! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 14:03'!
letter

	| x |
	x := self apply: #char.
	self pred: x isLetter.
	^ x! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 14:05'!
letterOrDigit

	| x |
	x := self apply: #char.
	self pred: x isAlphaNumeric.
	^ x! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 13:50'!
listOf

	| rule delim |
	rule := self apply: #anything.
	delim := self apply: #anything.
	^ self ometaOr: {
		[
			| x |
			x := self apply: rule.
			self genericMany: [
				self apply: #token withArgs: {delim}.
				self apply: rule
			] into: (OrderedCollection with: x)
		].
		[
			#()
		]
	}! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 14:07'!
lower

	| x |
	x := self apply: #char.
	self pred: x isLowercase.
	^ x! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 13:54'!
notLast

	| rule ans |
	rule := self apply: #anything.
	ans := self apply: rule.
	self lookahead: [self apply: rule].
	^ ans! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 14:02'!
number

	| x |
	x := self apply: #anything.
	self pred: x isNumber.
	^ x! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 15:42'!
range

	| a b x |
	a := self apply: #anything.
	b := self apply: #anything.
	x := self apply: #anything.
	self pred: (a <= x & x <= b).
	^ x! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 13:44'!
space

	| x |
	x := self apply: #char.
	self pred: x asciiValue <= 32.
	^ x! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 13:43'!
spaces

	^ self many: [self apply: #space]! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 14:02'!
string

	| x |
	x := self apply: #anything.
	self pred: x isString.
	^ x! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 11:33'!
symbol

	| x |
	x := self apply: #anything.
	self pred: x isSymbol.
	^ x! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 13:46'!
token

	| t |
	t := self apply: #anything.
	self apply: #spaces.
	^ self apply: #seq withArgs: {t}! !

!OMeta2 methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 14:07'!
upper

	| x |
	x := self apply: #char.
	self pred: x isUppercase.
	^ x! !

OMeta2 subclass: #OMeta2Examples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OMeta2Examples commentStamp: '<historical>' prior: 0!
Here's how to run these examples:

	OMeta2Examples match: 5 with: #fact.
	OMeta2Examples matchAll: '1234' with: #number.
	OMeta2Examples matchAll: 'abc123' with: #identifier.
	OMeta2Examples matchAll: #($a $b $c 1 2 3 #(4 5)) with: #structure.
	OMeta2Examples matchAll: 'howdy' with: #greeting.!

!OMeta2Examples methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 02:35'!
aSqueakMethod

	self inform: 'hello world'! !

!OMeta2Examples methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 02:36'!
anotherSqueakMethod

	self inform: 'good-bye world'! !

!OMeta2Examples methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 15:58'!
digit =

	// this example shows the new syntax for super rule applications
	// think of the ^ as an arrow that's pointing up to the parent grammar

	^digit:d -> [d digitValue]! !

!OMeta2Examples methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:58'!
fact 0 = [1],
fact _:n = fact(n - 1):m -> [n * m]

// this example shows that rules can have multiple definitions (they are tried in order)
! !

!OMeta2Examples methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 12:04'!
formTest =

	{[self inform: input hash printString] #foo #bar}
|	{[self inform: input hash printString] #bar}! !

!OMeta2Examples methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:36'!
greeting = <``howdy'' ``-ho''?>! !

!OMeta2Examples methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 15:45'!
identifier =

	// this is an example of the new <> operator

	spaces <letter (letter | digit)*>! !

!OMeta2Examples methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 15:48'!
identifierIdx =

	// this is an example of the new @<> operator

	spaces @<letter (letter | digit)*>! !

!OMeta2Examples methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:54'!
identifiers =

	([self inform: self pos printString] identifier)*! !

!OMeta2Examples methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 15:46'!
number =

	// this is an example of left recursion support

	number:n digit:d -> [n * 10 + d]
|	digit! !

!OMeta2Examples methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 15:46'!
structure =

	// this example shows how the {}s are used for matching sequenceable collections

	$a $b $c 1 2 3 {anything*}! !

OMeta2 subclass: #OMeta2Flattener
	instanceVariableNames: 'ws'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OMeta2Flattener methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:06'!
flatten

	| tree |
	tree := self apply: #anything.
	self apply: #iFlatten withArgs: {tree}.
	^ ws contents! !

!OMeta2Flattener methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:32'!
iFlatten

	^ self ometaOr: {
		[
			| s |
			s := self apply: #string.
			ws nextPutAll: s
		].
		[
			self form: [
				self many: [self apply: #iFlatten]
			]
		]
	}! !

!OMeta2Flattener methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:05'!
initialize

	super initialize.
	ws := (String new: 64) writeStream! !

OMeta2 subclass: #OMeta2NullOpt
	instanceVariableNames: 'didSomething'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

OMeta2NullOpt subclass: #OMeta2AndOrOpt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OMeta2AndOrOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:46'!
and =

	trans:x end setHelped -> [x]
|	transInside(#And):xs -> [xs addFirst: #And; yourself]! !

!OMeta2AndOrOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:46'!
or =

	trans:x end setHelped -> [x]
|	transInside(#Or):xs -> [xs addFirst: #Or; yourself]! !

!OMeta2AndOrOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:36'!
transInside :t =

	{exactly(t) transInside(t):xs} transInside(t):ys setHelped -> [xs, ys]
|	trans:x transInside(t):xs -> [xs addFirst: x; yourself]
|	empty -> [OrderedCollection new]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:44'!
and = trans*:xs -> [xs addFirst: #And; yourself]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:44'!
consby = trans:x -> [{#ConsBy. x}]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:44'!
form = trans:x -> [{#Form. x}]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:01'!
helped = ?[didSomething]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:44'!
idxconsby = trans:x -> [{#IdxConsBy. x}]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:30'!
initialize

	super initialize.
	didSomething := false! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:44'!
lookahead = trans:x -> [{#Lookahead. x}]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:44'!
many = trans:x -> [{#Many. x}]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:44'!
many1 = trans:x -> [{#Many1. x}]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:45'!
not = trans:x -> [{#Not. x}]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:45'!
opt = trans:x -> [{#Opt. x}]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:02'!
optimize = trans:x helped -> [x]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:45'!
or = trans*:xs -> [xs addFirst: #Or; yourself]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:45'!
rule = _:name _:temps trans:body -> [{#Rule. name. temps. body}]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:45'!
set = _:name trans:val -> [{#Set. name. val}]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:00'!
setHelped = [didSomething := true]! !

!OMeta2NullOpt methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:42'!
trans =

	{:t [t asLowercase asSymbol]:t ?[self class canUnderstand: t] apply(t):ans} -> [ans]
|	_! !

OMeta2 subclass: #OMeta2Optimizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OMeta2Optimizer methodsFor: 'as yet unclassified' stamp: 'aw 5/20/2009 12:53'!
optimizeRule = _:ans (foreign(OMeta2AndOrOpt. #optimize. ans):ans)* -> [ans]! !

OMeta2 subclass: #OMeta2RuleParser
	instanceVariableNames: 'temps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OMeta2RuleParser class methodsFor: 'as yet unclassified' stamp: 'aw 2/23/2009 10:07'!
isOMeta2Rule: aString

	^ [(self matchAll: aString with: #rule) first ~= #Squeak] on: OM2Fail do: [false]! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 13:58'!
application

	| kindOfApply rule args |
	self ometaOr: {
		[
			self apply: #token withArgs: {'^'}.
			kindOfApply := #SuperApp
		].
		[
			kindOfApply := #App
		]
	}.
	rule := self apply: #name.
	args := self apply: #args.
	^ (OrderedCollection with: kindOfApply)
		add: rule;
		addAll: args;
		yourself! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 14:03'!
args

	| ans |
	^ self ometaOr: {
		[
			self apply: #exactly withArgs: {$(}.
			ans := self apply: #listOf withArgs: {#squeakExpression. '.'}.
			self apply: #token withArgs: {')'}.
			ans
		].
		[
			self not: [self apply: #exactly withArgs: {$(}].
			#()
		]
	}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:53'!
characterLiteral

	| c |
	self apply: #spaces.
	self apply: #exactly withArgs: {$$}.
	c := self apply: #char.
	^ {#App. #exactly. c storeString}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 13:17'!
characters

	| xs |
	self apply: #token withArgs: {'``'}.
	xs := self many: [
		self not: [
			self apply: #exactly withArgs: {$'}.
			self apply: #exactly withArgs: {$'}.
		].
		self apply: #char
	].
	self apply: #exactly withArgs: {$'}.
	self apply: #exactly withArgs: {$'}.
	^ {#App. #seq. (String withAll: xs) storeString}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 13:33'!
expr

	| xs |
	xs := self apply: #listOf withArgs: {#expr4. '|'}.
	^ (OrderedCollection with: #Or)
		addAll: xs;
		yourself! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/23/2009 13:55'!
expr1

	| lit e |
	^ self ometaOr: {
		[
			lit := self ometaOr: {
				[self apply: #keyword withArgs: {'true'}].
				[self apply: #keyword withArgs: {'false'}].
				[self apply: #keyword withArgs: {'nil'}]
			}.
			{#App. #exactly. lit}
		].
		[self apply: #application].
		[self apply: #semanticAction].
		[self apply: #semanticPredicate].
		[self apply: #characters].
		[self apply: #tokenSugar].
		[self apply: #stringLiteral].
		[self apply: #symbolLiteral].
		[self apply: #numberLiteral].
		[self apply: #characterLiteral].
		[
			self apply: #token withArgs: {'{'}.
			e := self apply: #expr.
			self apply: #token withArgs: {'}'}.
			{#Form. e}
		].
		[
			self apply: #token withArgs: {'<'}.
			e := self apply: #expr.
			self apply: #token withArgs: {'>'}.
			{#ConsBy. e}
		].
		[
			self apply: #token withArgs: {'@<'}.
			e := self apply: #expr.
			self apply: #token withArgs: {'>'}.
			{#IdxConsBy. e}
		].
		[
			self apply: #token withArgs: {'('}.
			e := self apply: #expr.
			self apply: #token withArgs: {')'}.
			e
		]
	}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 13:24'!
expr2

	| x |
	^ self ometaOr: {
		[
			self apply: #token withArgs: {'~'}.
			x := self apply: #expr2.
			{#Not. x}
		].
		[
			self apply: #token withArgs: {'&'}.
			x := self apply: #expr2.
			{#Lookahead. x}
		].
		[
			self apply: #expr1
		]
	}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 16:27'!
expr3

	| x n |
	^ self ometaOr: {
		[
			x := self apply: #expr2.
			x := self apply: #optIter withArgs: {x}.
			self ometaOr: {
				[
					self apply: #exactly withArgs: {$:}.
					n := self apply: #nsName.
					temps add: n.
					{#Set. n. x}
				].
				[
					x
				]
			}
		].
		[
			self apply: #token withArgs: {':'}.
			n := self apply: #nsName.
			temps add: n.
			{#Set. n. {#App. #anything}}
		]
	}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 13:56'!
expr4

	| xs |
	xs := self many: [self apply: #expr3].
	^ (OrderedCollection with: #And)
		addAll: xs;
		yourself! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:04'!
initialize

	super initialize.
	temps := IdentitySet new! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 12:46'!
keyword

	| xs |
	xs := self apply: #anything.
	self apply: #token withArgs: {xs}.
	self not: [self apply: #letterOrDigit].
	^ xs! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 16:09'!
name

	self apply: #spaces.
	^ self apply: #nsName! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 01:17'!
nameFirst

	^ self apply: #letter! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 16:08'!
nameRest

	^ self ometaOr: {
		[self apply: #nameFirst].
		[self apply: #digit]
	}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/23/2009 10:50'!
nsName

	| xs |
	^ self ometaOr: {
		[
			xs := self apply: #firstAndRest withArgs: {#nameFirst. #nameRest}.
			(String withAll: xs) asSymbol
		].
		[
			self apply: #exactly withArgs: {$_}.
			^ #anything
		]
	}
! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:53'!
numberLiteral

	| sign ds |
	self apply: #spaces.
	sign := self ometaOr: {
		[
			self apply: #exactly withArgs: {$-}.
			self apply: #spaces.
			-1
		].
		[1]
	}.
	ds := self many1: [self apply: #digit].
	^ {#App. #exactly. (sign * (String withAll: ds) asNumber) storeString}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/25/2009 11:00'!
optIter

	| x |
	x := self apply: #anything.
	^ self ometaOr: {
		[
			self apply: #token withArgs: {'*'}.
			{#Many. x}
		].
		[
			self apply: #token withArgs: {'+'}.
			{#Many1. x}
		].
		[
			self apply: #token withArgs: {'?'}.
			self not: [self apply: #exactly withArgs: {$[}].
			{#Opt. x}
		].
		[
			x
		]
	}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 15:47'!
rule

	| n x xs squeakCode |
	^ self ometaOr: {
		[
			self not: [
				self many: [self super: OMeta2 apply: #space withArgs: #()].
				self apply: #nsName.
				self apply: #expr4.
				self apply: #token withArgs: {'='}
			].
			squeakCode := self consumedBy: [self many: [self apply: #char]].
			{#Squeak. squeakCode}
		].
		[
			n := self lookahead: [
				self many: [self super: OMeta2 apply: #space withArgs: #()].
				self apply: #nsName
			].
			x := self apply: #rulePart withArgs: {n}.
			xs := self many: [
				self apply: #token withArgs: {','}.
				self apply: #rulePart withArgs: {n}
			].
			self apply: #spaces.
			self apply: #end.
			{#Rule. n. temps asArray. (OrderedCollection with: #Or with: x) addAll: xs; yourself}
		]
	}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/17/2009 16:25'!
rulePart

	| ruleName b1 b2 |
	ruleName := self apply: #anything.
	self pred: (self apply: #name) = ruleName.
	b1 := self apply: #expr4.
	^ self ometaOr: {
		[
			self apply: #token withArgs: {'='}.
			b2 := self apply: #expr.
			{#And. b1. b2}
		].
		[
			b1
		]
	}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 12:05'!
semanticAction

	| e |
	self ometaOr: {
		[self apply: #token withArgs: {'->'}].
		[]
	}.
	self apply: #token withArgs: {'['}.
	e := self apply: #squeakExpression.
	self apply: #exactly withArgs: {$]}.
	^ {#Act. e}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/25/2009 10:58'!
semanticPredicate

	| e |
	self apply: #token withArgs: {'?['}.
	e := self apply: #squeakExpression.
	self apply: #exactly withArgs: {$]}.
	^ {#Pred. e}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 15:49'!
space

	^ self ometaOr: {
		[self super: OMeta2 apply: #space withArgs: #()].
		[self apply: #fromTo withArgs: {'/*'. '*/'}].
		[self apply: #fromTo withArgs: {'//'. String cr}].
		[
			self apply: #seq withArgs: {'//'}.
			self many: [self super: OMeta2 apply: #space withArgs: #()]
		]
	}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/25/2009 11:08'!
squeakExpression =

	foreign(O2SqueakRecognizer. #squeakExpr):ans spaces -> [ans]! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:53'!
stringLiteral

	| xs |
	self apply: #token withArgs: {''''}.
	xs := self many: [
		self ometaOr: {
			[
				self apply: #exactly withArgs: {$'}.
				self apply: #exactly withArgs: {$'}.
				$'
			].
			[
				self not: [self apply: #exactly withArgs: {$'}].
				self apply: #char
			]
		}
	].
	self apply: #exactly withArgs: {$'}.
	^ {#App. #exactly. (String withAll: xs) storeString}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:54'!
symbolLiteral

	" TODO: make this accept, e.g., #foo:bar: "
	| s |
	self apply: #token withArgs: {'#'}.
	s := self apply: #nsName.
	^ {#App. #exactly. s storeString}! !

!OMeta2RuleParser methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 00:33'!
tokenSugar

	| xs |
	self apply: #token withArgs: {'"'}.
	xs := self many: [
		self not: [self apply: #exactly withArgs: {$"}].
		self apply: #char
	].
	self apply: #exactly withArgs: {$"}.
	^ {#App. #token. (String withAll: xs) storeString}! !

OMeta2 subclass: #OMeta2RuleTranslator
	instanceVariableNames: 'grammarClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2'!

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 16:22'!
act

	| x |
	x := self apply: #string.
	^ {'('. x. ')'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 11:06'!
and

	| xs |
	xs := self many: [self apply: #trans.].
	^ {'(true ifTrue: ['. self delim: xs with: '. '. '])'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:29'!
app

	| rule args |
	rule := self apply: #symbol.
	^ self ometaOr: {
		[
			args := self many1: [self apply: #anything].
			args := self delim: args with: '. '.
			{'(self apply: '. rule storeString. ' withArgs: {'. args. '})'}
		].
		[
			{'(self apply: '. rule storeString. ')'}
		]
	}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/19/2009 23:34'!
consby

	| x |
	x := self apply: #trans.
	^ {'(self consumedBy: ['. x. '])'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 14:43'!
delim: aSequenceableCollection  with: anObject

	| first ans |
	
	first := true.
	ans := OrderedCollection new.
	aSequenceableCollection do: [:x |
		first ifTrue: [first := false] ifFalse: [ans add: anObject].
		ans add: x
	].
	^ ans! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 16:06'!
form

	| x |
	x := self apply: #trans.
	^ {'(self form: ['. x. '])'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:56'!
idxconsby

	| x |
	x := self apply: #trans.
	^ {'(self indexConsumedBy: ['. x. '])'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 16:07'!
lookahead

	| x |
	x := self apply: #trans.
	^ {'(self lookahead: ['. x. '])'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 16:10'!
many

	| x |
	x := self apply: #trans.
	^ {'(self many: ['. x. '])'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 16:10'!
many1

	| x |
	x := self apply: #trans.
	^ {'(self many1: ['. x. '])'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 16:08'!
not

	| x |
	x := self apply: #trans.
	^ {'(self not: ['. x. '])'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:35'!
opt

	| x |
	x := self apply: #trans.
	^ {'(self opt: ['. x. '])'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:51'!
or

	| xs x |
	xs := self many: [
		x := self apply: #trans.
		{'['. x. ']'}
	].
	^ {'(self ometaOr: {'. self delim: xs with: '. '. '})'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 16:22'!
pred

	| x |
	x := self apply: #string.
	^ {'(self pred: ('. x. '))'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 19:20'!
rule

	| name temps body |
	name := self apply: #symbol.
	temps := self apply: #anything.
	temps := temps select: [:t | (grammarClass instVarNames includes: t) not].
	temps := temps collect: [:t | t asString].
	body := self apply: #trans.
	^ {name. ' |'. self delim: temps with: ' '. ' | ^ '. body}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 16:09'!
set

	| n v |
	n := self apply: #symbol.
	v := self apply: #trans.
	^ {'('. n asString. ' := '. v. ')'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 00:07'!
squeak

	^ self apply: #string! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:46'!
superapp

	| rule args |
	rule := self apply: #symbol.
	args := self many: [self apply: #anything].
	args := self delim: args with: '. '.
	^ {'(self super: '. grammarClass superclass name. ' apply: '. rule storeString. ' withArgs: {'. args. '})'}! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:46'!
trans

	| type ans |
	self form: [
		type := self apply: #symbol.
		ans := self apply: type asLowercase asSymbol
	].
	^ ans! !

!OMeta2RuleTranslator methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:35'!
translate

	grammarClass := self apply: #anything.
	^ self apply: #trans! !

!OMeta2Base class methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:52'!
compilerClass

        ^ OMeta2Compiler! !

!OMeta2Base class methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 12:52'!
debugMatch: anObject with: aRule

	^ self debugMatch: anObject with: aRule withArgs: #()! !

!OMeta2Base class methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 12:58'!
debugMatch: anObject with: aRule withArgs: args

	^ self debugMatchAll: {anObject} readStream with: aRule withArgs: args! !

!OMeta2Base class methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 12:35'!
debugMatchAll: aSequenceableCollection with: aRule

	^ self debugMatchAll: aSequenceableCollection with: aRule withArgs: #()! !

!OMeta2Base class methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 12:53'!
debugMatchAll: aSequenceableCollection with: aRule withArgs: args

	^ self matchStream: aSequenceableCollection readStream with: aRule withArgs: args withPlaybackDebugging: true! !

!OMeta2Base class methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 11:53'!
match: anObject with: aRule

	^ self match: anObject with: aRule withArgs: #()! !

!OMeta2Base class methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 12:55'!
match: anObject with: aRule withArgs: args

	^ self matchAll: {anObject} readStream with: aRule withArgs: args! !

!OMeta2Base class methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 15:39'!
matchAll: aSequenceableCollection with: aRule

	^ self matchAll: aSequenceableCollection with: aRule withArgs: #()! !

!OMeta2Base class methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 12:57'!
matchAll: aSequenceableCollection with: aRule withArgs: args

	^ self matchStream: aSequenceableCollection readStream with: aRule withArgs: args withPlaybackDebugging: false! !

!OMeta2Base class methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 14:14'!
matchStream: aReadStream with: aRule withArgs: args withPlaybackDebugging: debugging

	| input matcher ans|
	input := OM2LazyStream for: aReadStream withPos: 1.
	matcher := self new initInput: input.
	[
		matcher apply: #empty withArgs: args.
		ans := matcher apply: aRule.
		matcher apply: #end.
		^ ans
	] on: OM2Fail do: [:e |
		| curr prev prevPrev |
		debugging ifFalse: [e signal].
		curr := input.
		prev := nil.
		prevPrev := nil.
		[curr notNil] whileTrue: [
			prevPrev := prev.
			prev := curr.
			curr := curr basicTail
		].
		curr := prevPrev ifNotNil: [prevPrev] ifNil: [prev].
		self inform: 'will halt each time matcher reaches ', curr printString.
		matcher
			initInput: input;
			forgetEverything.
		curr ifNil: [self error: 'you''ve found a bug -- please tell Alex'].
		curr become: (OM2StreamDebugger for: curr copy).
		matcher haltingPoint: curr.
		matcher apply: #empty withArgs: args.
		ans := matcher apply: aRule.
		matcher apply: #end.
		^ ans
	]! !

!OMeta2Base class methodsFor: 'as yet unclassified' stamp: 'tak 4/7/2009 14:58'!
matcherOn: aReadStream

	| input matcher |
	input := OM2LazyStream for: aReadStream withPos: 1.
	matcher := self new initInput: input.
	^ matcher! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/18/2009 16:05'!
? aBoolean

	^ self pred: aBoolean! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 15:13'!
anything

	| ans |
	ans := input head.
	input := input tail.
	^ ans! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 14:01'!
apply

	| aRule |
	aRule := self apply: #anything.
	^ self apply: aRule! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 14:09'!
apply: aRule

	" A memoRec is an association whose key is the answer,
	  and whose value is the next input. Failers pretend to
     be memoRecs, but throw a fail in response to #value "
	| memo memoRec |
	input == haltingPoint ifTrue: [self halt].
	memo := input memo.
	memoRec := memo at: aRule ifAbsent: [nil].
	memoRec ifNil: [
		| origInput failer ans |
		origInput := input.
		failer := OM2Failer new.
		memo at: aRule put: failer.
		ans := self perform: aRule.
		memoRec := ans -> input.
		memo at: aRule put: memoRec.
		failer used ifTrue: [
			" left recursion detected "
			| sentinel keepGoing |
			sentinel := input.
			keepGoing := true.
			[keepGoing] whileTrue: [
				[
					input := origInput.
					ans := self perform: aRule.
					input == sentinel ifTrue: [OMeta2Fail signal].
					memoRec key: ans value: input.
				] on: OM2Fail do: [keepGoing := false]
			]
		]		
	].
	input := memoRec value.
	^ memoRec key! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 13:39'!
apply: aRule withArgs: args

	args reverseDo: [:a | input := OM2Stream new initHead: a tail: input].
	^ self perform: aRule! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/19/2009 23:17'!
consumedBy: aBlock

	| origInput i ws |
	origInput := input.
	aBlock value.
	ws := WriteStream on: origInput inputSpecies new.
	i := origInput.
	[i == input] whileFalse: [
		ws nextPut: i head.
		i := i tail
	].
	^ ws contents! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 14:11'!
foreign

	| aGrammar aRule g ans |
	aGrammar := self apply: #anything.
	aRule := self apply: #anything.
	g := aGrammar new initInput: (OM2StreamProxy for: input).
	ans := g apply: aRule.
	input := g input target.
	^ ans! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 13:17'!
forgetEverything

	input transitiveForgetEverything.
	om2streams valuesDo: [:s | s transitiveForgetEverything]! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 11:33'!
form: aBlock

	| v origInput |
	v := self apply: #anything.
	self pred: (v isCollection and: [v isSequenceable and: [v isSymbol not]]).
	origInput := input.
	input := om2streams at: v ifAbsentPut: [OM2LazyStream for: v readStream withPos: 1].
	aBlock value.
	self apply: #end.
	input := origInput.
	^ v! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 15:19'!
genericMany: aBlock into: anOrderedCollection

	[
		| origInput |
		origInput := input.
		[anOrderedCollection addLast: aBlock value] on: OM2Fail do: [
			input := origInput.
			^ anOrderedCollection
		].
		true
	] whileTrue! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/27/2009 11:25'!
haltingPoint: anOM2Stream

	haltingPoint := anOM2Stream! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:57'!
indexConsumedBy: aBlock

	| from to |
	from := self pos.
	aBlock value.
	to := self pos.
	^ from -> to! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 14:06'!
initInput: i

	input := i! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/26/2009 11:16'!
initialize

	super initialize.
	om2streams := IdentityDictionary new! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 14:10'!
input

	^ input! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 13:48'!
lookahead: aBlock

	| origInput ans |
	origInput := input.
	ans := aBlock value.
	input := origInput.
	^ ans! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 13:56'!
many1: aBlock

	^ self genericMany: aBlock into: (OrderedCollection with: aBlock value)! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 13:56'!
many: aBlock

	^ self genericMany: aBlock into: OrderedCollection new! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/25/2009 11:28'!
not: aBlock

	| origInput |
	origInput := input.
	[aBlock value] on: OM2Fail do: [
		input := origInput.
		^ true
	].
	OMeta2Fail signal! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/25/2009 11:28'!
ometaOr: choices

	| origInput |
	origInput := input.
	choices do: [:choice |
		input := origInput.
		[^ choice value] on: OM2Fail do: []
	].
	OMeta2Fail signal! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:33'!
opt: aBlock

	^ self ometaOr: {
		[aBlock value].
		[nil]
	}! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/20/2009 14:48'!
pos

	^ input pos! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/25/2009 11:28'!
pred: aBooleanValue

	" may want to have the compiler inline this automatically, for performance "
	aBooleanValue ifTrue: [^ true].
	OMeta2Fail signal! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 16:16'!
seq

	| xs |
	xs := self apply: #anything.
	xs do: [:x |
		" may want to inline #apply:withArgs: below as an
		  optimization, since this rule gets used a lot "
		self apply: #exactly withArgs: {x}
	].
	^ xs
	! !

!OMeta2Base methodsFor: 'as yet unclassified' stamp: 'aw 2/16/2009 15:03'!
super: superclass apply: aRule withArgs: args

	args reverseDo: [:a | input := OM2Stream new initHead: a tail: input].
	^ self perform: aRule withArguments: #() inSuperclass: superclass! !
O2SqueakRecognizer initialize!
